# !/bin/sh
#
# Post Install script file for BLACK BOX COMredirect Linux driver
# 
# Copyright (c) 2003-2009  Black Box Corporation
#
###########################################################################################



echo "Running Post Install script..."


# determine the version of the running kernel to control next phase of install
KERNEL_VER_B=`uname -r | awk -F. '{printf "%d", $2}'`

if [ "$KERNEL_VER_B" -ge 5 ]; then
	MODPROBE_CONF=/etc/modprobe.conf
	MODPROBE_DIR=/etc/modprobe.d
	MODPROBED_NAME=COMredirect.conf
else
	MODPROBE_CONF=/etc/modules.conf
	MODPROBE_DIR=/etc/modutils
fi

if ! test -f ${MODPROBE_CONF} ; then
  if test -d ${MODPROBE_DIR} ; then
	  MODPROBE_CONF=${MODPROBE_DIR}/${MODPROBED_NAME}
	  # if file doesn't exist then create blank one
	  if ! test -f ${MODPROBE_CONF} ; then
		  echo > ${MODPROBE_CONF}
	  fi
  else
	  echo "${MODPROBE_CONF} or ${MODPROBE_DIR}/ do not exist, generating ${MODPROBE_CONF}"
	  echo > ${MODPROBE_CONF}
  fi
fi
# if /etc/modules.conf or /etc/modprobe.conf files is automatically generated
# then use  MODPROBE_DIR
if grep -q "automatically generated" ${MODPROBE_CONF} ; then
	MODPROBE_CONF=${MODPROBE_DIR}/${MODPROBED_NAME}
	# if file doesn't exist then create blank one
	if ! test -f ${MODPROBE_CONF} ; then
		echo > ${MODPROBE_CONF}
	fi
fi


if test -w ${MODPROBE_CONF} ; then
	if ! grep -q ptyx ${MODPROBE_CONF} ; then
		echo "Updating ${MODPROBE_CONF}"
		echo "# ptyx module support" >> ${MODPROBE_CONF}
		echo "alias char-major-62 ptyx" >> ${MODPROBE_CONF}
		if [ -x /sbin/depmod -a -e /lib/modules/`/bin/uname -r`/modules.dep ] ; then
			/sbin/depmod -a 
		fi
	else
		    echo "${MODPROBE_CONF} already configured"
	fi
else
  echo "ERROR: ${MODPROBE_CONF} not writable or does not exist. This should not happen."
  exit 1
fi

# Let the system know we are installing our startup scripts
CHKCONFIG_BIN=""
if [ -x /sbin/chkconfig ]
then 
	CHKCONFIG_BIN="/sbin/chkconfig"
fi
if [ -x /usr/sbin/chkconfig ]
then
	CHKCONFIG_BIN="/usr/sbin/chkconfig"
fi
if [ $CHKCONFIG_BIN ]
then
	$CHKCONFIG_BIN --add COMredirect
else
	echo "COMredirect startup scripts must be manually added"
fi




# Force dependency checks
if [ -e /sbin/depmod ]
then
	/sbin/depmod -a
fi

/etc/init.d/COMredirect restart

echo

