//*****************************************************************************
//
//	compat.h	- provide compatability between kernel versions.
//



#define	TTY_DRIVER_NO_DEVFS 	0

#if (LINUX_VERSION_CODE < 0x02030F) /*2.3.15-- XX get correct version  */
#define __exit
#endif

#ifndef set_current_state
#define set_current_state(state_value)			\
	do { current->state = state_value; } while (0)
#endif

#ifndef DECLARE_WAITQUEUE
#define DECLARE_WAITQUEUE(wait, current) \
	struct wait_queue wait = { current, NULL }
#define init_waitqueue_head(head)	init_waitqueue(head)
#endif



/*
 * Compatibility with the new module_init() code
 */
#ifndef module_init
#ifdef MODULE
#define module_init(x)	int init_module(void) { return x(); }
#define module_exit(x)	void cleanup_module(void) { x(); }
#define	THIS_MODULE		(&__this_module)
#else
#define module_init(x)	/* nothing */
#define module_exit(x)	/* nothing */
#define	THIS_MODULE		NULL
#endif
#endif	/* module_init */

/* New termbits definitions */
#ifndef TIOCM_OUT1
#define TIOCM_OUT1	0x2000
#define TIOCM_OUT2	0x4000
#endif

#ifndef TIOCM_LOOP
#define TIOCM_LOOP	0x8000
#endif

/* Define new-style CPU configs */
#if defined(__i386__) && defined(CPU)
#if CPU == 386 && !defined(CONFIG_M386)
#define CONFIG_M386
#endif
#if CPU == 486 && !defined(CONFIG_M486)
#define CONFIG_M486
#endif
#endif
