#!/bin/bash
#

OPENSSLDIR=$1
OPENSSLVER=$2
PROBLEM_TEXT=$3

if [ "$PROBLEM_TEXT" = "1" ]; then
	echo ""
	echo ""
	echo "******************************************************************************"
	echo "* Unable to locate the OpenSSL headers!"
	echo "*"
	echo "* The BLACK BOX COMredirect driver requires the OpenSSL layer."
	echo "*"
else if [ "$PROBLEM_TEXT" = "2" ]; then
	echo ""
	echo ""
	echo "******************************************************************************"
	echo "* Unable to locate the OpenSSL libcrypto library!"
	echo "*"
	echo "* The BLACK BOX COMredirect driver requires the OpenSSL libcrypto library."
	echo "*"
else if [ "$PROBLEM_TEXT" = "3" ]; then
	echo ""
	echo ""
	echo "******************************************************************************"
	echo "* Your OpenSSL headers do not match your library!"
	echo "*"
	echo "* The BLACK BOX COMredirect driver requires the OpenSSL header version to match"
	echo "* the OpenSSL library version installed on your system."
	echo "*"
else if [ "$PROBLEM_TEXT" = "4" ]; then
	echo ""
	echo ""
	echo "******************************************************************************"
	echo "* Your OpenSSL version is not current enough!"
	echo "*"
	echo "* The BLACK BOX COMredirect driver requires the OpenSSL version to be at least 0.9.7"
	echo "*"
else if [ "$PROBLEM_TEXT" = "5" ]; then
	echo ""
	echo ""
	echo "******************************************************************************"
	echo "* The COMredirect software cannot use the existing version of OpenSSL!"
	echo "*"
	echo "* The BLACK BOX COMredirect driver requires the OpenSSL software"
	echo "*"
fi
fi
fi
fi
fi

if [ -d $OPENSSLDIR ]; then
	echo "* This driver will use the shipped version of the OpenSSL package that comes"
	echo "* with this driver package."
	echo "*"
	echo "* COMredirect version of Openssl already installed in $OPENSSLDIR."
	echo "******************************************************************************"
	echo ""
	sleep 5
else
	echo "* This driver will use the shipped version of the OpenSSL package that comes"
	echo "* with this driver package."
	echo "*"
	echo "* There will be a considerable amount of extra time spent"
	echo "* compiling this driver package (anywhere from 5 - 60 minutes),"
	echo "* because the OpenSSL library will also be compiled."
	echo "******************************************************************************"
	echo ""
  	DONE="not done"
	while [ "$DONE" = "not done" ]; do
		echo
	    echo -n "Do you want to continue with the installation? (yes or no ): "
	    read answer
	    case "$answer" in
	      yes|y)  	DONE=done
			      	;; 

	      no|n)		exit 255
			    	;;

		  *)		;;	
	    esac
	done
	echo "-----------------------------------------"
	echo "Uncompressing, untarring $OPENSSLVER.tar.gz"
	INSTALL_PWD=$PWD
	echo pwd = $INSTALL_PWD
	mkdir -p /etc/COMredirect
	cd	/etc/COMredirect
	if [ "$?" != "0" ]; then
	  echo Cannot change to /etc/COMredirect directory 
	  echo "***********************************************"
	  exit 1
	fi
  	tar -xvzf $INSTALL_PWD/$OPENSSLVER.tar.gz 1>/dev/null
	echo "Now configuring, making $OPENSSLVER... Please wait..."	
	cd $OPENSSLVER; ./config shared 2>/dev/null; make 2>/dev/null
	cd $INSTALL_PWD
	echo "-----------------------------------------"
fi
