# !/bin/sh
#
# Unistall script file for BLACK BOX COMredirect Linux driver
# 
# Copyright (c) 2003-2009  Black Box Corporation
#
###########################################################################################

	
# determine the version of the running kernel to control next phase of install
KERNEL_VER_B=`uname -r | awk -F. '{printf "%d", $2}'`
if [ "$KERNEL_VER_B" -ge 5 ]; then
	MODPROBE_CONF=/etc/modprobe.conf
	MODPROBE_DIR=/etc/modprobe.d
	MODPROBED_NAME=COMredirect.conf
	DRIVER_MODULE=ptyx.ko
else
	MODPROBE_CONF=/etc/modules.conf
	MODPROBE_DIR=/etc/modutils
	DRIVER_MODULE=ptyx.o
fi

if ! test -f ${MODPROBE_CONF} ; then
  if test -d ${MODPROBE_DIR} ; then
	  MODPROBE_CONF=${MODPROBE_DIR}/${MODPROBED_NAME}
  fi
fi
# if /etc/modules.conf or /etc/modprobe.conf files is automatically generated
# then use  MODPROBE_DIR
if grep -q "automatically generated" ${MODPROBE_CONF} ; then
	MODPROBE_CONF=${MODPROBE_DIR}/${MODPROBED_NAME}
fi

bindir=/usr/bin
LEVEL="2 3 5"
base=$(if [ -d /etc/init.d/rc2.d ] ; then echo /etc/init.d ; elif [ -d /etc/rc2.d ] ; then  echo /etc/ ; else echo UNKONWN  ; fi)
SHAREDSSLVER=".0.9.7"

/etc/init.d/COMredirect stop

if test ! -w ${MODPROBE_CONF}; then
	echo "Cannot find ${MODPROBE_CONF}. Nothing to remove from ${MODPROBE_CONF}"
else
	echo Removing lines from ${MODPROBE_CONF}
	mv ${MODPROBE_CONF} ${MODPROBE_CONF}.crd.save
	sed -e "/alias char-major-62 ptyx/d"									\
		-e "/# ptyx module support/d" ${MODPROBE_CONF}.crd.save > ${MODPROBE_CONF}
	#cleanup
	rm ${MODPROBE_CONF}.crd.save 
	if test -f /etc/modprobe.d/${MODPROBED_NAME} ; then
		rm -f /etc/modprobe.d/${MODPROBED_NAME}
	fi
fi

rm -f  /lib/modules/`uname -r`/misc/${DRIVER_MODULE}
rm -f  /usr/bin/addports
rm -f  /usr/bin/cleanports
rm -f  /usr/bin/COMredirectd
rm -f  /usr/bin/crdadm
rm -fR  /usr/share/doc/COMredirect



rm -f /etc/COMredirect/crdlogin
rm -f /etc/COMredirect/addlogins
rm -f /etc/COMredirect/rmlogins
rm -f /etc/COMredirect/swirl
cp -f /etc/COMredirect/config.crd /etc/COMredirect/config.crd.tarsave
cp -f /etc/COMredirect/sslcfg.crd /etc/COMredirect/sslcfg.crd.tarsave
cp -f /etc/COMredirect/pktfwdcfg.crd /etc/COMredirect/pktfwdcfg.crd.tarsave
rm -f /etc/COMredirect/config.crd 
rm -f /etc/COMredirect/sslcfg.crd 
rm -f /etc/COMredirect/pktfwdcfg.crd 
rm -f /etc/COMredirect/lib/libssl.so${SHAREDSSLVER}
rm -f /etc/COMredirect/lib/libcrypto.so${SHAREDSSLVER}
rm -f /etc/COMredirect/postinstall.sh
rm -f /etc/COMredirect/uninstall.sh


# Let the system know we are removing our starup scripts in /
CHKCONFIG_BIN=""
if [ -x /sbin/chkconfig ]
then 
	CHKCONFIG_BIN="/sbin/chkconfig"
fi
if [ -x /usr/sbin/chkconfig ]
then
	CHKCONFIG_BIN="/usr/sbin/chkconfig"
fi
if [ $CHKCONFIG_BIN ]
then
	$CHKCONFIG_BIN --del COMredirect
else
	echo "COMredirect startup scripts must be manually removed"
fi



echo Removing done
