#
# spec file for BLACK BOX COMredirect driver for Linux
# 
# Copyright (c) 2003-2016  Black Box Corporation
#
# please send bugfixes or comments to BLACK BOX
#
Summary:	BLACK BOX COMredirect driver package for Linux
Name:		COMredirect
Version:	6.8.0
Release: 2
License:	GPL
Group:		System/Utilities


Source:		COMredirect-%{version}-%{release}.tgz
Distribution:	BLACK BOX COMredirect
Vendor:		BLACK BOX.
Packager:	BLACK BOX

Provides:	COMredirect
Autoreqprov:	yes
BuildRequires:	gcc


BuildRoot:	%{_tmppath}/%{name}-build
    
%description
This package allows you to use the BLACK BOX terminal and device servers 
as a local port. Read /usr/share/doc/COMredirect/README for more info. 

%prep

%setup
	if "$RPM_BUILD_ROOT" = "/" ]; 	then
		echo This package requires a seperate BuildRoot to build properly.
		exit 1
	fi
./tar_install.sh rpm_build
%define debug_package %{nil}

#############################################################################
%build
read SSL < ./ssl
export SSL
make DESTDIR=$RPM_BUILD_ROOT/ 

#############################################################################
%install
read SSL < ./ssl
export SSL
make DESTDIR=$RPM_BUILD_ROOT/ install

#remove testopenssl so that it will be rebuilt with the actual openssl being used.
if [ "$SSL" = "1" ]; then
  rm -f testopenssl
  CHECK_LIBS=yes
  export CHECK_LIBS
  make DESTDIR=$RPM_BUILD_ROOT/ TESTOPENSSL=yes testopenssl
  ./testopenssl
  if [ "$?" != "0" ]; then
	  echo Openssl version still not current!!! 
	  exit 2
  fi
fi


#############################################################################
%files -f /tmp/files
/usr/bin/addports
/usr/bin/cleanports
/usr/bin/COMredirectd
/usr/bin/crdadm
/usr/share/doc/COMredirect/README
/usr/share/doc/COMredirect/crd.h
/usr/share/doc/COMredirect/crd_ver.h
/usr/share/doc/COMredirect/ptyx
/etc/init.d/COMredirect
/etc/COMredirect/swirl
/etc/COMredirect/crdlogin
/etc/COMredirect/addlogins
/etc/COMredirect/rmlogins
/etc/COMredirect/uninstall.sh
/etc/COMredirect/postinstall.sh
%config /etc/COMredirect/config.crd
%config /etc/COMredirect/sslcfg.crd
%config /etc/COMredirect/pktfwdcfg.crd


#############################################################################
%clean
	if [ "$RPM_BUILD_ROOT" != "/" ]; 	then
		rm -rf $RPM_BUILD_ROOT
	fi

	
#############################################################################
%post
read MAXINSTPORTS < /tmp/maxinstports
export MAXINSTPORTS
/etc/COMredirect/postinstall.sh

depmod -a &> /dev/null



#############################################################################
%preun
	if [ -d /etc/COMredirect -a -f /etc/COMredirect/uninstall ]; then
		/etc/COMredirect/uninstall
	fi

#############################################################################
%postun
	# Force a depmod after we have been removed.
	if [ -e /sbin/depmod ]
	then
		/sbin/depmod -a
	fi
	
	echo Removing done

